



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android自定义View之CircleView</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android自定义View之CircleView</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 21:53:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>Android自定义View之CircleView</h1>
<blockquote><p>版权声明：本文为博主原创文章，未经博主允许不得转载。</p>
<p>转载请表明出处：<a href="http://www.cnblogs.com/cavalier-/p/5999037.html" rel="external nofollow noreferrer">http://www.cnblogs.com/cavalier-/p/5999037.html</a></p></blockquote>
<h2>前言</h2>
<p>大家好，我是Cavalier,这次和大家分享一下《Android自定义View之CircleView》,不废话,下面上效果图。</p>
<p><img referrerpolicy="no-referrer"src="http://ww4.sinaimg.cn/large/8410c284gw1f94yb3cx8ag20c00lcq7g.gif"></p>
<h3>分析</h3>
<p>需求</p>
<pre class="prettyprint linenums"><code>1：随机换颜色的一个view<br />
2：可以设置文字<br />
</code></pre>
<h3>动手</h3>
<p><strong>Setup1:继承自View,重写三个构造函数</strong></p>
<pre class="prettyprint linenums"><code>public class CircleView extends View {<br />
    public CircleView(Context context) {<br />
        this(context,null);<br />
    }

    public CircleView(Context context, AttributeSet attrs) {<br />
        this(context, attrs,0);<br />
    }

    public CircleView(Context context, AttributeSet attrs, int defStyleAttr) {<br />
        super(context, attrs, defStyleAttr);<br />
    }<br />
}<br />
</code></pre>
<p>上面代码中重写了三个构造函数，其中第一个是用于直接new对象，第二个是从xml创建时没有指定style时调用,第三个是指定了style时调用,通过this可以直接指向第三个构造参数，所有初始化可以直接写在第三个构造参数中</p>
<p><strong>Setup2:声明所需的变量</strong></p>
<pre class="prettyprint linenums"><code>private Paint mTextPain;                        //初始化画笔<br />
private String mText = &quot;&quot;;                      //初始化文字<br />
private int radius;                             //当前View的半径

...<br />
 public CircleView(Context context, AttributeSet attrs, int defStyleAttr) {<br />
    super(context, attrs, defStyleAttr);<br />
    configPaint();<br />
}

private void configPaint() {<br />
    mTextPain = new Paint();<br />
    mTextPain.setColor(Color.WHITE);            //设置画笔颜色为白色<br />
    mTextPain.setAntiAlias(true);               //开启抗锯齿，平滑文字和圆弧的边缘<br />
    mTextPain.setTextAlign(Paint.Align.CENTER); //设置文本位于相对于原点的中间<br />
}<br />
</code></pre>
<p>上面代码在第三个构造函数调用了configPaint函数</p>
<p><strong>Setup3:重新onDraw函数</strong></p>
<pre class="prettyprint linenums"><code>@Override<br />
protected void onDraw(Canvas canvas) {<br />
    super.onDraw(canvas);<br />
    int width = getWidth() / 2;                                 //获取宽度一半<br />
    int height = getHeight() / 2;                               //获取高度一半<br />
    radius = Math.min(width, height);                           //设置半径为宽或者高的最小值<br />
    //paint bg<br />
    mTextPain.setColor(Color.parseColor(getRandomColor()));     //设置画笔颜色为随机颜色<br />
    canvas.drawCircle(width, height, radius, mTextPain);        //利用canvas画一个圆

    //paint font<br />
    mTextPain.setColor(Color.WHITE);                            //设置画笔白颜色<br />
    mTextPain.setTextSize(dp2px(16));                           //设置字体大小为16dp<br />
    Paint.FontMetrics fontMetrics = mTextPain.getFontMetrics(); //获取字体测量对象<br />
    canvas.drawText(mText, 0, mText.length(), radius            //利用canvas画上字<br />
            , radius + Math.abs(fontMetrics.top + fontMetrics.bottom) / 2, mTextPain);<br />
}<br />
</code></pre>
<p>上面代码中先获取到当前view的宽和高，取其中最小值作为背景的半径，设置了随机颜色做背景，且利用FontMetrics获取了文字的绘制位置</p>
<p><strong>Setup4:添加两个辅助函数，dp2px和getRandomColor</strong></p>
<pre class="prettyprint linenums"><code>/**<br />
 * 给View设置文字<br />
 * @param str<br />
 */<br />
public void setText(String str) {<br />
    if(!TextUtils.isEmpty(str)){<br />
        if(str.length()&gt;1){<br />
            mText = str.substring(0,1);<br />
        }else {<br />
            mText = str;<br />
        }<br />
    }else {<br />
        mText =  &quot;&quot;;<br />
    }<br />
    invalidate();<br />
}<br />
</code></pre>
<p>当然，我们需要将设置文字暴露给使用者，这里利用了invalidate让CircleView重新绘制一遍，目的是更改内中的文字</p>
<p><strong>Setup5:添加两个辅助函数，dp2px和getRandomColor</strong></p>
<pre class="prettyprint linenums"><code>/**<br />
 * dp转px<br />
 *<br />
 * @param dp<br />
 * @return<br />
 */<br />
private int dp2px(int dp) {<br />
    // px = dp * (dpi / 160)<br />
    DisplayMetrics metrics = getContext().getResources().getDisplayMetrics();<br />
    int dpi = metrics.densityDpi;<br />
    return (int) (dp * (dpi / 160f) + 0.5f);<br />
}

/**<br />
 * 获取随机颜色<br />
 *<br />
 * @return<br />
 */<br />
private String getRandomColor() {<br />
    List&lt;String&gt; colorList = new ArrayList&lt;String&gt;();<br />
    colorList.add(&quot;#303F9F&quot;);<br />
    colorList.add(&quot;#FF4081&quot;);<br />
    colorList.add(&quot;#59dbe0&quot;);<br />
    colorList.add(&quot;#f57f68&quot;);<br />
    colorList.add(&quot;#f8b552&quot;);<br />
    colorList.add(&quot;#990099&quot;);<br />
    colorList.add(&quot;#90a4ae&quot;);<br />
    colorList.add(&quot;#7baaf7&quot;);<br />
    colorList.add(&quot;#4dd0e1&quot;);<br />
    colorList.add(&quot;#4db6ac&quot;);<br />
    colorList.add(&quot;#aed581&quot;);<br />
    colorList.add(&quot;#fdd835&quot;);<br />
    colorList.add(&quot;#f2a600&quot;);<br />
    colorList.add(&quot;#ff8a65&quot;);<br />
    colorList.add(&quot;#f48fb1&quot;);<br />
    colorList.add(&quot;#7986cb&quot;);<br />
    colorList.add(&quot;#DEB887&quot;);<br />
    colorList.add(&quot;#FF69B4&quot;);<br />
    return colorList.get((int) (Math.random() * colorList.size()));<br />
}<br />
</code></pre>
<p>补充了这两个辅助函数后，代码已经完成了</p>
<h3>How to use？</h3>
<p>在XML中使用</p>
<pre class="prettyprint linenums"><code>...

&lt;com.ram.testdemo.view.CircleView<br />
    android:id=&quot;@+id/cv&quot;<br />
    android:layout_width=&quot;50dp&quot;<br />
    android:layout_height=&quot;50dp&quot;/&gt;

...<br />
</code></pre>
<p>这里注意调用时是使用你自己的Class文件全路径。</p>
<p>在java中使用</p>
<pre class="prettyprint linenums"><code>CircleView mCircleView = (CircleView) findViewById(R.id.cv);<br />
mCircleView.setText(&quot;哈哈&quot;);<br />
</code></pre>
<h3>Souce Code</h3>
<pre class="prettyprint linenums"><code>public class CircleView extends View {<br />
    private Paint mTextPain;                        //初始化画笔<br />
    private String mText = &quot;&quot;;                      //初始化文字<br />
    private int radius;                             //当前View的半径

    public CircleView(Context context) {<br />
        this(context, null);<br />
    }

    public CircleView(Context context, AttributeSet attrs) {<br />
        this(context, attrs, 0);<br />
    }

    public CircleView(Context context, AttributeSet attrs, int defStyleAttr) {<br />
        super(context, attrs, defStyleAttr);<br />
        configPaint();<br />
    }

    private void configPaint() {<br />
        mTextPain = new Paint();<br />
        mTextPain.setColor(Color.WHITE);            //设置画笔颜色为白色<br />
        mTextPain.setAntiAlias(true);               //开启抗锯齿，平滑文字和圆弧的边缘<br />
        mTextPain.setTextAlign(Paint.Align.CENTER); //设置文本位于相对于原点的中间<br />
    }

    @Override<br />
    protected void onDraw(Canvas canvas) {<br />
        super.onDraw(canvas);<br />
        int width = getWidth() / 2;                                 //获取宽度一半<br />
        int height = getHeight() / 2;                               //获取高度一半<br />
        radius = Math.min(width, height);                           //设置半径为宽或者高的最小值<br />
        //paint bg<br />
        mTextPain.setColor(Color.parseColor(getRandomColor()));     //设置画笔颜色为随机颜色<br />
        canvas.drawCircle(width, height, radius, mTextPain);        //利用canvas画一个圆

        //paint font<br />
        mTextPain.setColor(Color.WHITE);                            //设置画笔白颜色<br />
        mTextPain.setTextSize(dp2px(16));                           //设置字体大小为16dp<br />
        Paint.FontMetrics fontMetrics = mTextPain.getFontMetrics(); //获取字体测量对象<br />
        canvas.drawText(mText, 0, mText.length(), radius            //利用canvas画上字<br />
                , radius + Math.abs(fontMetrics.top + fontMetrics.bottom) / 2, mTextPain);<br />
    }

    /**<br />
     * 给View设置文字<br />
     * @param str<br />
     */<br />
    public void setText(String str) {<br />
        if(!TextUtils.isEmpty(str)){<br />
            if(str.length()&gt;1){<br />
                mText = str.substring(0,1);<br />
            }else {<br />
                mText = str;<br />
            }<br />
        }else {<br />
            mText =  &quot;&quot;;<br />
        }<br />
        invalidate();<br />
    }

    /**<br />
     * dp转px<br />
     *<br />
     * @param dp<br />
     * @return<br />
     */<br />
    public int dp2px(int dp) {<br />
        // px = dp * (dpi / 160)<br />
        DisplayMetrics metrics = getContext().getResources().getDisplayMetrics();<br />
        int dpi = metrics.densityDpi;<br />
        return (int) (dp * (dpi / 160f) + 0.5f);<br />
    }

    /**<br />
     * 获取随机颜色<br />
     *<br />
     * @return<br />
     */<br />
    private String getRandomColor() {<br />
        List&lt;String&gt; colorList = new ArrayList&lt;String&gt;();<br />
        colorList.add(&quot;#303F9F&quot;);<br />
        colorList.add(&quot;#FF4081&quot;);<br />
        colorList.add(&quot;#59dbe0&quot;);<br />
        colorList.add(&quot;#f57f68&quot;);<br />
        colorList.add(&quot;#f8b552&quot;);<br />
        colorList.add(&quot;#990099&quot;);<br />
        colorList.add(&quot;#90a4ae&quot;);<br />
        colorList.add(&quot;#7baaf7&quot;);<br />
        colorList.add(&quot;#4dd0e1&quot;);<br />
        colorList.add(&quot;#4db6ac&quot;);<br />
        colorList.add(&quot;#aed581&quot;);<br />
        colorList.add(&quot;#fdd835&quot;);<br />
        colorList.add(&quot;#f2a600&quot;);<br />
        colorList.add(&quot;#ff8a65&quot;);<br />
        colorList.add(&quot;#f48fb1&quot;);<br />
        colorList.add(&quot;#7986cb&quot;);<br />
        colorList.add(&quot;#DEB887&quot;);<br />
        colorList.add(&quot;#FF69B4&quot;);<br />
        return colorList.get((int) (Math.random() * colorList.size()));<br />
    }<br />
}<br />
</code></pre>
<h2>结尾</h2>
<p>本篇中，我们掌握了自定义View的invalidate重绘,和FontMetrics的文本位置测量，还了解onDraw中的canvas的用法。如文中有描述不巧当的地方请指出，谢谢。</p>
<blockquote><p><a href="https://developer.android.com/guide/topics/ui/custom-components.htm" rel="external nofollow noreferrer">参考 : Android custom-components</a></p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93w1d0q.html">1Z0-053 争议题目解析501</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ovoglq.html">Oracle EBS FND User Info API &lpar;转&rpar;  EBS用户账号密码职责相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn54k2q.html">转载C&num;下RSA算法的实现（适用于支付宝和易宝支付）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kzoy58.html">SpringMVC下的Shiro权限框架的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96wgmjq.html">点击含下拉菜单的列表&sol;表单按钮：通过JS创建虚拟按钮并点击</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmexde9.html">怎么使用Docker搭建PHP开发环境呢？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm1n2e9.html">MySQL&lpar;二&rpar; &mdash;&mdash; 数据类型与操作数据表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdewlpz9.html">highstock实现股票分时</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0gg7lq.html">HW1&period;7</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zoom29.html">ios专题 － sandbox机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj651y9.html">centos 6&period;0中文输入法的设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmwyx79.html">C&num;  调用浏览器打开网址</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo5n1xq.html">centos6 更新gcc glibc2&period;17</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2jd7pq.html">MySQL针对对账数据，每天每个店只能产生一条对账记录，对数据库数据进行添加联合唯一索引设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jmn7jq.html">nGrinder Loadrunner vs nGrinder</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rjmlz8.html">leetcode 307 Range Sum Query</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rw2k28.html">xbeePROS1发送的数据在802&period;15&period;4网络中有多大时延？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw46d48.html">『OpenCV3』Mat简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvp1mg8.html">nginx支持android、ios、微信扫一扫</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2x2719.html">mysql  Error&lowbar;code&colon; 1593</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/oqvkj4y9.html">微信支付之JSAPI开发-第二篇：业务流程详解与方案设计</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvk3nj9.html">Delphi里如何让程序锁定在桌面上，win&plus;d都无法最小化</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qygoxxq.html">BeanUtils&period;populate的作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/49ggx009.html">Google V8编程详解（四）Context</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jlg3lq.html">Wince 6&period;0适用 &period;NET 使用HttpRequest的Post上传文件，服务端的Web API接收Post上传上来的文件 代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/49ggkll9.html">datetimepicker一个不错的日历android特效</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q23n139.html">java规范（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnwe2xq.html">Rust的力量</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnwew3q.html">右键添加&amp;quot&semi;用vim打开&amp;quot&semi;文件选项</a>
			</li>
						<li><a href="https://www.batexi.com/a/49ggy279.html">方法的覆盖&lpar;override&rpar;、重载&lpar;overload&rpar;和重写&lpar;overwrite&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
